    include     \masm32\include\masm32rt.inc    ; defaults to .386

    .686

    include     \masm32\macros\timers.asm      ; requires a pentium

    LOOPCOUNT equ 100000;0

    PROCS TEXTEQU <lszLenSSE,Ratch,szLen,szLength,Jens_fast_strlen,mmxlen,StrLen2>

LastString=9999
    SIZES TEXTEQU <LastString>
    ALGNS TEXTEQU <0,1,2,3>

    HPROC TEXTEQU <szLength>        ; Function to calculate length for header

    %FOR proc,<PROCS>
         proc proto :DWORD
    ENDM

    MAXWIDTH  equ 20
    HDRWIDTH  equ 9
    COLWIDTH  equ 5

.data

  %FOR extra,<ALGNS>
    %FOR len,<SIZES>
         align 16
         db extra dup (0)
         str&extra&b&len& db len dup ('X'),0
    ENDM
  ENDM
.code

align 16

sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4

sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM

.code

align 16

start:

	; make a real test string with all ascii characters-
    %FOR extra,<ALGNS>
		mov edx,offset str&extra&bLastString
		mov al,1
		mov ecx,LastString
@@:		
		mov [edx],al
		inc al
		.if al==0
			inc al
		.endif
		inc edx
		dec ecx
		jnz @b
	endm		
		 

    print chr$("Test routines for correctness:",13,10)
    %FOR extra,<ALGNS>
    %FOR proc,<PROCS>
        print fld$(chr$("&proc&"),HDRWIDTH)
        %FOR len,<SIZES>
            invoke proc,ADDR str&extra&b&len&
            ;invoke proc,ADDR str2b&len&
	        print fld$(ustr$(eax),COLWIDTH,1)
        ENDM
        print chr$(13,10)
    ENDM
    ENDM



    print chr$(13,10)
    print fld$(chr$("Proc/Bytes"),HDRWIDTH)


    %FOR len,<SIZES>
        invoke HPROC, ADDR str0b&len&
        print fld$(ustr$(eax),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("=========="),HDRWIDTH)
    %FOR len,<SIZES>
        invoke StrLen,ADDR str0b&len&
        print fld$(" ====",COLWIDTH)
    ENDM
    print chr$(13,10)

  %FOR extra,<ALGNS>
    print chr$(13,10)
    print chr$("Misaligned by &extra& bytes:",13,10)
    %FOR proc,<PROCS>
        print fld$(chr$("&proc&"),HDRWIDTH)
        %FOR len,<SIZES>
            counter_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
                invoke proc,ADDR str&extra&b&len&
            counter_end
            mov ebx,eax
            print fld$(ustr$(ebx),COLWIDTH,1)
        ENDM
	    print chr$(13,10)
    ENDM
  ENDM
    mov   eax,input(13,10,"Press enter to exit...")
    exit

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

szLength proc src:DWORD
            mov     eax, [esp + 4]          ; point eax to start of string
            test    eax, 3
            jnz     fixalign                ; jmp to fix misalignment
            align   4
lenscan:    mov    edx, [eax]               ; load next four bytes
resume:     lea     ecx, [edx - 1010101h]
            not     edx                     ; on each byte in ecx: (byte-1) & ~byte & 80h
            and     ecx, 80808080h
            and     edx, ecx
            jnz     found                   ; branch if found

            mov     edx, [eax + 4]          ; load next four bytes
            add     eax, 8                  ; advance ptr (twice)
            lea     ecx, [edx - 1010101h]
            not     edx                     ; on each byte in ecx: (byte-1) & ~byte & 80h
            and     edx, 80808080h
            and     edx, ecx
            jz      lenscan                 ; repeat while no zeros found
            sub     eax, 4                  ; back off to last dword

found:      sub     eax, [esp + 4]          ; subtract the base address
            test    ecx, 8080h              ; test first two bytes
            jz      upper2                  ; jmp if not found in the lower 2 bytes
            shr     ecx, 8                  ; set carry from bit7 of 1st byte
            sbb     eax, -1                 ; return eax = eax + (1-carry)
            ret     4
upper2:     shl     ecx, 9                  ; set carry from bit7 of 3rd byte
            sbb     eax, -3                 ; return eax = (eax+2) + (1-carry)
            ret		1*4

	    align   4
fixalign:   mov     ecx, eax
            and     eax,not 3		    ; eax points to aligned addr            
            and     ecx, 3                  ; ecx = bytes to skip
            shl     ecx, 3                  ; ecx = bits to skip
            mov     edx, 1
            shl     edx, cl                 ; put cl 1's into edx from the bottom up
            sub     edx, 1
            or      edx, [eax]              ; combine with first four bytes
            jmp     resume                  ; start up in the aligned search
szLength endp


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

lszLenSSE proc pString:DWORD    ; Donkey's SSE strlen for long strings
.xmm
        mov eax,[esp+4]
	nop
        nop                     ; fill in stack frame+mov to 8 bytes

	pxor mm0,mm0
        nop                     ; fill pxor to 4 bytes
	pxor mm1,mm1
        nop                     ; fill pxor to 4 bytes

    @@:                         ; this is aligned to 16 bytes
        movq mm0,[eax]
        pcmpeqb mm0,mm1
	add eax,8
        pmovmskb ecx,mm0
        or ecx,ecx
        jz @B

        sub eax,[esp+4]

	bsf ecx,ecx
	sub eax,8
	add eax,ecx

	emms

        ret 1*4

lszLenSSE endp

align 16

Ratch proc junk:dword      ; from Ratch           ;it all begins here
 MOV EAX,[ESP+DWORD]       ;address of string

 .REPEAT                   ;searching string ....
   MOV EDX,[EAX]           ;next 4 byte gulp (DWORD)
   ADD EAX,DWORD           ;EAX=character pointer
   LEA ECX,[EDX-01010101H] ;propagate if byte is zero
   NOT EDX                 ;set up test pattern
   AND EDX,ECX             ;leftmost bit of zero byte should now be set
   AND EDX,080808080H      ;sieve out zero bytes
 .UNTIL !ZERO?             ;check the next DWORD

                           ;we now know the current DWORD contains a zero byte
 SUB EAX,DWORD+BYTE        ;compensate for entry additions into loops

 .REPEAT                   ;searching current DWORD ...
   INC EAX                 ;increase word count if no carry from shift
   ROR EDX,8               ;bring leftmost bit of each byte into carry flag
 .UNTIL CARRY?             ;if carry flag set, byte is zero

 SUB EAX,[ESP+DWORD]       ;subtract beginning of string to get length

 RET DWORD                 ;all done, and string length in EAX

Ratch endp


align 16

Jens_fast_strlen PROC item:DWORD

mov ecx, [esp+4] 

@@:
mov eax, dword ptr [ecx]
add ecx, 4

lea edx, [eax - 01010101h]
xor eax, edx
and eax, 80808080h
jz @B
and eax, edx
jz @B

bsf edx, eax

sub edx, 4
shr edx, 3

lea eax, [ecx + edx - 4]
sub eax, [esp+4] 

RET 4

Jens_fast_strlen ENDP

align 16

mmxlen proc item:DWORD
    mov eax, [esp+4]
    pxor MM1, MM1
    jmp check
align 16

    @@:
    cmp byte ptr [eax], 0
    jz finished
    inc eax
check:
    test al, 15
    jnz @B

align 16
    @@:
    movq MM0, [eax]
    movq MM2, [eax+8]
    pcmpeqb MM0, MM1
    pcmpeqb MM2, MM1
    pmovmskb edx, MM0
    pmovmskb ecx, MM2
    add eax, 16
    test edx, edx
    jnz @F
    test ecx, ecx
    jz @B
    @@:
    mov dh, cl
    bsf ecx, edx
    lea eax, [ecx+eax-16]
finished:
    sub eax, [esp+4]
    ret 4
mmxlen endp 

align 16


xmmlen proc item:DWORD
    mov eax, [esp+4]
    db 66h
    pxor XMM1, XMM1
    jmp check
align 16

    @@:
    cmp byte ptr [eax], 0
    jz finished
    inc eax
check:
    test al, 3
    jnz @B
align 16
@@:
    test al, 28
    jz XMMGO
    mov edx, [eax]
    lea ecx, [edx-01010101h]
    not ecx
    add eax, 4
    and ecx, 80808080h
    and ecx, edx
    jz @B
    test cx, cx
    jnz @F
    shr ecx, 16
    add eax, 2
    @@:
    cmp cl, 1
    adc eax, -4
finished:
    sub eax, [esp+4]
    ret 4


align 16
    XMMGO:
    db 66h              ;
    movq MM0, [eax]     ; masm 6.14, no SSE2...
    db 66h              ;
    movq MM2, [eax+16]  ;
    db 66h
    pcmpeqb MM0, MM1
    db 66h
    pcmpeqb MM2, MM1
    db 66h
    pmovmskb edx, MM0
    db 66h
    pmovmskb ecx, MM2
    add eax, 32
    test edx, edx
    jnz @F
    test ecx, ecx
    jz @B
    @@:
    shl ecx, 16
    or edx, ecx
    bsf ecx, edx
    lea eax, [ecx+eax-32]
    sub eax, [esp+4]
    ret 4
xmmlen endp 

align 16

StrLen2 proc item:DWORD

    push ebx
    push esi
    push edi

    mov esi, 80808080h
    mov edi, 00008080h

    mov     eax,[esp+16]           ; get pointer to string
    lea     edx,[eax+3]            ; pointer+3 used in the end

  align 4
  @@: 
  REPEAT 3
    mov     ebx,[eax]              ; read first 4 bytes
    add     eax,4                  ; increment pointer
    lea     ecx,[ebx-01010101h]    ; subtract 1 from each byte
    not     ebx                    ; invert all bytes
    and     ecx,ebx                ; and these two
    and     ecx,esi
    jnz     ilbl
ENDM
    mov     ebx,[eax]              ; read first 4 bytes
    add     eax,4                  ; increment pointer
    lea     ecx,[ebx-01010101h]    ; subtract 1 from each byte
    not     ebx                    ; invert all bytes
    and     ecx,ebx                ; and these two
    and     ecx,esi
    jz      @B                     ; no zero bytes, continue loop

  ilbl:
    test    ecx, edi               ; test first two bytes
    jnz     @F
    shr     ecx,16                 ; not in the first 2 bytes
    add     eax,2
  @@:
    shl     cl,1                   ; use carry flag to avoid branch
    sbb     eax,edx                ; compute length

    pop edi
    pop esi
    pop ebx


    ret     4

StrLen2 endp


OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
end start
